﻿-- Visitor Radar
-- by Jadya
-- EU-Well of Eternity

local addonName, addonTable = ...
local L = addonTable.L -- localization
VisitorRadar = {}
local addon = VisitorRadar
local version = 1000

local addontitle = "|cff00AAFFVisitor Radar|r"
local vricon = "Interface\\icons\\INV_Sigil_Freya"

local visitor, visitors_table
local function generateVisitorsTable(tag)
 visitors_table = {
  [L.Get(tag.."harrison_jones")] = {},
  [L.Get(tag.."elite_quest")] = {},
  [L.Get(tag.."dungeon_raid")] = {},
  [L.Get(tag.."trader_herb")] = {},
 }
end

local updateFrame = CreateFrame("Frame")
local lastupdate = 0
local function update(self, elapsed)
 local zone = GetZoneText()
 if C_Garrison.IsUsingPartyGarrison() or (zone ~= GetMapNameByID(971) and zone ~= GetMapNameByID(976) and 
    zone ~= GARRISON_TOWN_HALL_HORDE and zone ~= GARRISON_TOWN_HALL_ALLIANCE) then
  return
 end

 local t = GetTime()
 if lastupdate < t - 0.1 then lastupdate = t else return end

 for k,v in pairs(visitors_table) do
 
  local function checkName(name)
   if not name then return end
   
   if name == k then
    visitor.t = time() + GetQuestResetTime()
	visitor.name = name
	--updateFrame:Hide()
   end
  end

  checkName(UnitName("mouseover"))
  checkName(UnitName("target"))
 end
end
updateFrame:SetScript("OnUpdate", update)
updateFrame:Show()

addon.eventframe = CreateFrame("FRAME","VREventFrame")
addon.eventframe:RegisterEvent("VARIABLES_LOADED")
function addon.eventframe.VARIABLES_LOADED()

 faction = UnitFactionGroup("player")
 generateVisitorsTable(faction == "Alliance" and "A_" or "H_")
 
 if VisitorRadar_CharData == nil then VisitorRadar_CharData = {} end
 if VisitorRadar_Options == nil then VisitorRadar_Options = {} end
 local O = VisitorRadar_Options

 -- default options
 if O["show_in_guildframe"] == nil then O["show_in_guildframe"] = true end
 if O["noguild"] == nil then O["noguild"] = false end
 --
 
 O["Version"] = version
 
 addonTable:SetupConfigFrame()
 
 if VisitorRadar_Character == nil then VisitorRadar_Character = {} end
 visitor = VisitorRadar_Character

 if visitor.t and time() > visitor.t then
  print(addontitle.." - Visitor "..visitor.name.." removed (outdated)")
  visitor.name = nil
  visitor.t = nil
 end
end

addon.eventframe:SetScript("OnEvent", function(self, event, ...) addon.eventframe[event](...) end)