-- Visitor Radar
-- by Jadya EU - Well of Eternity
-- communication
local addonName, addonTable = ...
local addon = VisitorRadar

--local pName = GetUnitName("player")
--local pRealm = GetRealmName()
--local pID = pName.."-"..pRealm

-- message prefixes
local gvr_pref = "##GVRDATA##"
RegisterAddonMessagePrefix("##GVRDATA##")

local function sendmsg(pref, s, chan, target)
 SendAddonMessage(pref, s, chan, target)
end

local function processmsg(s, ...)

 local input = {strsplit("@", s)}

 -- this character doesn't want to show his visitor
 if input[1] == "hide" then
  addonTable:ToggleButton(fullName, true)
  return
 elseif input[1] == "data" then
  local character = select(2,...)
  local ct = VisitorRadar_CharData[character]

  local _, visitor = unpack(input)
  --print("data received from ".. character)
  -- we already have data
  if ct and ct.visitor and ct.visitor.name == visitor and ct.t > time() then return end

  VisitorRadar_CharData[character] = { ["visitor"] = { ["name"] = visitor },
                                       ["t"] = time() + GetQuestResetTime()}
  -- tell the guildroster frame that a character button needs to be shown
  addonTable:ToggleButton(fullName)
 end

end

local lastpulse = 0
function addonTable:Pulse()
 local t = time()
 if lastpulse > t - 2 then return end
 
 -- invisible to guild
 local pref = VisitorRadar_Options["noguild"] and "hide" or "data"
 local vname = VisitorRadar_Character and VisitorRadar_Character.name
 if pref == "hide" or vname then
  local n = vname or ""
  -- additional data
  local add = ""
  --
  local output = pref.."@"..n.."@"..add
  sendmsg(gvr_pref, output, "GUILD")
 end
 lastpulse = t
end

local updateFrame = CreateFrame("Frame")
local lastupdate = 0
local function update(self, elapsed)
 local t = GetTime()

 if lastupdate < t - 10 then lastupdate = t else return end
 
 --Pulse()
end
updateFrame:SetScript("OnUpdate", update)
updateFrame:Show()

addon.eventframe:RegisterEvent("CHAT_MSG_ADDON")
function addon.eventframe.CHAT_MSG_ADDON(pref, ...)
 if pref == gvr_pref then
  processmsg(...)
 end
end